#!/usr/bin/env ruby

require 'scene'

class Tetris < Gosu::Window
  attr_reader :font

  WIDTH = 480
  HEIGHT = 480
  FONT_SIZE = 40

  def initialize
    super WIDTH, HEIGHT
    self.caption = "Tetris"
    @font = Gosu::Font.new(FONT_SIZE)
    @menu_scene = MainMenuScene.new(self)
    @hs_scene = HighScoreScene.new(self)
    @game_scene = nil
    @scene = @menu_scene
  end

  def update
    @scene.update
  end

  def draw
    @scene.draw
  end

  def button_down(id)
    @scene.button_down id
  end

  def new_game
    @menu_scene.add_continue
    @game_scene = GameScene.new(self, @menu_scene.difficulty)
    @scene = @game_scene
  end

  def high_score
    @scene = @hs_scene
  end

  def add_score(score)
    @hs_scene.add_score(score)
  end

  def continue
    @scene = @game_scene
  end

  def game_running?
    @game_scene&.game_running?
  end

  def menu
    #code to pause game
    @scene = @menu_scene
  end
end
